<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_HotelType ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_HotelType extends AbstractStructArrayBase
{
    /**
     * The HotelType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_HotelType[]
     */
    public $HotelType;
    /**
     * Constructor method for ArrayOfJP_HotelType
     * @uses ArrayOfJP_HotelType::setHotelType()
     * @param \StructType\JP_HotelType[] $hotelType
     */
    public function __construct(array $hotelType = array())
    {
        $this
            ->setHotelType($hotelType);
    }
    /**
     * Get HotelType value
     * @return \StructType\JP_HotelType[]|null
     */
    public function getHotelType()
    {
        return $this->HotelType;
    }
    /**
     * Set HotelType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelType[] $hotelType
     * @return \ArrayType\ArrayOfJP_HotelType
     */
    public function setHotelType(array $hotelType = array())
    {
        foreach ($hotelType as $arrayOfJP_HotelTypeHotelTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_HotelTypeHotelTypeItem instanceof \StructType\JP_HotelType) {
                throw new \InvalidArgumentException(sprintf('The HotelType property can only contain items of \StructType\JP_HotelType, "%s" given', is_object($arrayOfJP_HotelTypeHotelTypeItem) ? get_class($arrayOfJP_HotelTypeHotelTypeItem) : gettype($arrayOfJP_HotelTypeHotelTypeItem)), __LINE__);
            }
        }
        $this->HotelType = $hotelType;
        return $this;
    }
    /**
     * Add item to HotelType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelType $item
     * @return \ArrayType\ArrayOfJP_HotelType
     */
    public function addToHotelType(\StructType\JP_HotelType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_HotelType) {
            throw new \InvalidArgumentException(sprintf('The HotelType property can only contain items of \StructType\JP_HotelType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HotelType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_HotelType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_HotelType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_HotelType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_HotelType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_HotelType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelType
     */
    public function getAttributeName()
    {
        return 'HotelType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_HotelType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
